package iterators;

import java.util.*;

public class LinkedList{
	private DNode head;
	private DNode tail;
	
	public LinkedList() {
		head = null;
		tail = null;
	}
	
	public void addNode(Object o) {
	   DNode d = new DNode();
	   d.setData(o);
	   if (head == null) {
	    	head = d;
			tail = d;
	   } else {
			d.setNext(head);
			head.setPrev(d);
			head = d;
		}
	}
	
  private class LocalLifoIterator implements Enumeration {
    private DNode curNode;
    //  this is a lifo iterator
    
    public LocalLifoIterator() {
      curNode = head;
    }
    public boolean hasMoreElements() {
      return curNode != null; 
    }
    public Object nextElement() {
      Object c = curNode;
      
	 Object data = ((DNode)c).getData(); 
	  curNode = curNode.getNext();
      return data; 
    }
  }
  
  private class LocalFifoIterator implements Enumeration {
	 private DNode curNode;
	 //  this is a fifo iterator
    
	 public LocalFifoIterator() {
	   curNode = tail;
	 }
	 public boolean hasMoreElements() {
	   return curNode != null; 
	 }
	 public Object nextElement() {
	   Object c = curNode;
      
	  Object data = ((DNode)c).getData(); 
	   curNode = curNode.getPrev();
	   return data; 
	 }
   } // LocalFifoIterator
  
  public Enumeration lifoIterator() {
    return new LocalLifoIterator();
  }
  
  public Enumeration fifoIterator() {
	 return new LocalFifoIterator();
   }
  
  public static void main ( String[] args ) {
  	LinkedList ll = new LinkedList();
  	Integer j = new Integer(1);
  	String s = "Silly";
  	Integer i = new Integer(2);
  	String o = "object";
  	ll.addNode(j);
  	ll.addNode(s);
  	ll.addNode(i);
  	ll.addNode(o); 
    Enumeration enumerator = ll.lifoIterator();
    while (enumerator.hasMoreElements() ) {
    	System.out.println(enumerator.nextElement());
    }
    System.out.println("let's see the fifo one");
	enumerator = ll.fifoIterator();
	   while (enumerator.hasMoreElements() ) {
		   System.out.println(enumerator.nextElement());
	   }
  }

}

// Exercise:  what do we have to do to add another
// iterator that did a fifo on the list?
