package treemap; 

// A small program to help you understand this material -- this is a tricky one!
// Draw pictures and run through some simple examples on paper. 
// TODO:  Make sure you understand it, make changes -- try to predict
// what the output will be given some changes, explore the questions I've posed..

import java.util.Vector;
import java.util.Enumeration;
import shared.TreeNode;
import recursivetree.RecursiveTree; 

public class TreeMap {
	
	 TreeNode root; // root node in our treemap
  
     // constructor
     public TreeMap() {
            // create the tree (recursively!) and set the root node
            RecursiveTree rtree = new RecursiveTree(3,3);
            root = rtree.getRoot();
      }    

      private int calculateDescendents(TreeNode root) {             
            int descendents = 0;
            // TODO: store the children using a Vector  -- why use a Vector? why not an array?
            Vector children = root.getChildren();                            
            for (int i=0; i<children.size(); i++) {                           
                  TreeNode child = (TreeNode) children.elementAt(i);
                  // TODO:  recursive call, what is the stopping condition?
                  descendents += calculateDescendents(child);
            }

            // debug print statement here to check if it is working!         
            System.out.println("The number of descendents for this node is: "
                  		+ descendents);
           root.setData(descendents); // store number of descendents in the node
           return descendents + 1; //TODO: we add one for this element, 
            						// if we don't add one what happens? Try it and explain why.
      } 
      
     
      // TODO: try adding a postorder traversal
      private class PreOrderIterator implements Enumeration {
   			private int curNode;
   			private Vector pre;
   			private int curSize;

   			public PreOrderIterator() { 
      			pre = new Vector();
      			curNode = 0;
      			curSize = 0;
      			preorder(root); // populate our vector with the order we want
      			curNode = 0;
   			}
   		
   			// TODO:  if we added a postorder traversal we wouldn't have to change
   			// this method very much....
   			// for a levelorder it would be very different..... see the class notes
   			// that gives pseudocode for the different traversals
   			// and finally what about printing an euler tour?
   	   		private void preorder(TreeNode t) {
   				if (t != null) {
      				pre.add(t);
      				curNode++; curSize++;
      				Vector children = t.getChildren();
      				for (int i=0; i<children.size(); i++) {                           
                  		TreeNode child = (TreeNode)children.elementAt(i);
                  		preorder(child);
            		}
   				}
   	   		}
   	   		
			public boolean hasMoreElements() {
   				return curNode < curSize;
			}
			public Object nextElement() {
   				return pre.elementAt(curNode++);
			}

	   } // end of private class
	
	   // return a preorder traversal iterator
       public Enumeration preIterator() {
        	return new PreOrderIterator();
       }   		          

      public static void main(String args[]) {
            TreeMap test = new TreeMap();
            
            //test if the preorder traversal works properly!
            Enumeration testPreIt = test.preIterator();   
            while (testPreIt.hasMoreElements()) {
  		          System.out.println("Data for this node is: " +
  		         		((TreeNode)testPreIt.nextElement()).getData() );
  			}  
  			
  			 //we do preorder to see if calculatedescendants works correctly: 
  			test.calculateDescendents(test.root);
            Enumeration testPreIt2 = test.preIterator();   
            while (testPreIt2.hasMoreElements()) {
  		          System.out.println("Number of descendants for this node is: " +
  		          		((TreeNode)testPreIt2.nextElement()).getData() );
  			}          
      }
}

 

 
