
// try to create one of these! -- review of abstract classes
abstract class Instrument {
	
	public Instrument() {
		System.out.println("instrument constructor called");
	} 
  
	 // must be implemented by a non-abstract subclass
	 abstract void play(); 

	 static void tune(Instrument i) {
	  	System.out.println(" in tune" ); 
	    i.play();   
	    // if it refers to a wind class, it will call the wind's play method
	 }
}

// Wind objects are instruments
// because they have the same interface:
public class Wind extends Instrument {
	
	public Wind() {
		System.out.println("wind constructor called");
	} 

   // must provide an implementation because this class is not abstract	 
   public void play() 
   {
   	   System.out.print("wind is playing");
   } 
 	
  public static void main(String[] args) {
  	 Wind flute = new Wind();
     flute.play();
     // TODO: next call is to a static method, what does that mean?
     Instrument.tune(flute); // Upcasting, cast to an instrument
  }
} 