import java.applet.Applet;
import java.awt.*;

/*
 * This Java Applet draws a checkerboard recursively.
 * 
 * With this applet you can visualize recursion.  
 * 
 * - Notice the order the squares are drawn in.  You can change this 
 * order to some extent.  
 * - Also, try changing the depth of recursion, note that it is 
 * exponential.
 * - You can also upgrade this board.  Try adding black squares and
 * checker pieces.  Have some fun with it! 
 *
 */
public class FourSquare extends Applet {

	private Graphics g;

	/*
	 * Set the initial size of the applet (400 by 400 pixels)
	 */
	public void init(){
		resize(400, 400);
	}
	
	/*
	 * Instead of a main method, applets have a paint method.
	 * This is where our recursion begins.
	 */
	public void paint(Graphics g){
		
		int x = 10; //x co-ordinate for top left corner of the checkerboard
		int y = 10; //y co-ordinate for top left corner of the checkerboard
		int size = 100;  //total size of the checkerboard
		int depth = 0; //initial depth or level of recursion
		
		//draw a square
		fourSquare(x, y, size, depth);
	}

	/*
	 * Draws a square.  If maximum recursive depth has not been 
	 * reached, draw four squares within the current square.
	 */
	public void fourSquare (int x, int y, int size, int depth){

		g = getGraphics();
	
		//draw a black square
		g.setColor (Color.black);  
		g.drawRect (x, y, size, size);  //look at the Java API and see
										//what Graphics can do!  Try
										//to draw a filled square!
		
		System.out.println("Drew square: " + x + " " + y + " " + size);	
		
		int n = 300;  // wait n milliseconds
		try { Thread.sleep (n); } catch (InterruptedException e){}

		//here we check against a maximum recursive depth
		if (depth < 3){
			
			//change size and depth for next level		
			depth++; 
			size = size/2;
				
			System.out.println("Recurse!!!");
			
			//the order of the recursive calls determines the order
			//the squares are drawn in.
			fourSquare(x, y, size, depth);
			fourSquare(x + size, y, size, depth);
			fourSquare(x, y + size, size, depth);
			fourSquare(x + size, y + size, size, depth);
		}
	}
}