package Josephus;

// from the textbook

public class NodeQueue implements Queue {
	int size = 0;
	DLNode head = null;
	DLNode tail = null; 
	
	public void enqueue(Object obj) {
	DLNode node = new DLNode();
	node.setElement(obj);
	node.setNext(null); // node will be new tail node
	if (size == 0)
	  head = node; // special case of a previously empty queue
	else
	  tail.setNext(node); // add node at the tail of the list
	tail = node; // update the reference to the tail node
	size++;
  }
  
  public Object dequeue() throws EmptyQueueException {
	  if (size == 0)
		throw new EmptyQueueException("Queue is empty.");
	  Object obj = head.getElement();
	  head = head.getNext();
	  size--;
	  if (size == 0)
		tail = null; // the queue is now empty
	  return obj;
	}
	
	public int size () {
		return size;
	}
	
	public Object front () throws EmptyQueueException {
		if (size ==0)
			throw new EmptyQueueException("Queue is empty.");
		return head.getElement();
	} 
	
	public boolean isEmpty() {
		return (size ==0); 
	}


}