/**
 * Doubly linked list node
 * For a singly linked list, remove the prev field
 */
package doublelinkedlist;

public class DNode {
	private Object data; //holds all types of Objects (abstraction)
	private DNode next;  //the pointers
	private DNode prev;

	public DNode(Object data, DNode next, DNode prev) {
		this.data = data;
		this.next = next;
		this.prev = prev;
	}

	public DNode() {
		this(null, null, null);
	}

	public DNode(Object data) {
		this(data, null, null);
	}
	public Object getData() {
		return data;
	}
	public DNode getNext() {
		return next;
	}
	public DNode getPrev() {
		return prev;
	}
	public void setData(Object data) {
		this.data = data;
	}
	public void setNext(DNode next) {
		this.next = next;
	}
	public void setPrev(DNode prev) {
		this.prev = prev;
	}
}