/**
 * @author nernst
 *
 */
package doublelinkedlist; 

public class LinkedStack extends DoubleLinkedList implements Stack {

	public LinkedStack() {
		super(); // don't really need this
	}
	public Object pop() {
		return deleteFirst();
	}
	public void push(Object data) {
		insertFirst(data);
	}
	public Object top() {
		return getFirst();
	}
	// methods size() and isEmpty()
	// are inherited from DoubleLinkedList

	//test program
	public static void main(String[] args) {
		
		Stack s = new LinkedStack();
		s.push(new Integer(4));
		s.push(new Integer(7));
		s.push(new Integer(9));
		s.push(new String("CSc115"));
		s.push(new String("CSc160"));
		s.push(new Double(3.14));

		while (! s.isEmpty()) {
			Object obj = s.pop();
			System.out.print( "Size = " + s.size() + " Obj = " );
			if ( obj instanceof Integer ) {
				int k = ( (Integer) obj ).intValue();
				System.out.println(k);
			} else if ( obj instanceof String ) {
				String str = (String) obj;
				System.out.println(str);
			} else {
				System.out.println("unknown");
			}
		}
		if (s.isEmpty())
			System.out.println("Empty Stack");
	}
}
