/**
 * SSLInterface.java
 * @version 1.0.0
 * @author Bette Bultena
 */

package evaluator; 

import java.util.*;

/**
 * Interface for a linked list.
 * Presently, the linked list can only insert and remove integers from
 * the front of the list.
 */

public interface SSLInterface {

/**
 * Inserts an object into the front position of the singly linked list.
 * @param item The object to be inserted.
 */
	public void addFirst( Object item );

/**
 * Removes an object from the front position of the singly linked list.
 * @return The object at the beginning of the list.
 * @throws NoSuchElementException if the list is empty.
 */
	public Object removeFirst() throws
		NoSuchElementException;

/**
 *  Return the element at the head of the list without removing it.
 * @return The element at the front of the list.
 * @throws NoSuchElementException if the list is empty.
 */
 	public Object getFirstValue() throws NoSuchElementException;
/**
 * @return The size of the list.
 */
 	public int size();
/**
 * Returns a string representation of each element in the list.
 * @returns the string.
 */
	public String toString();
}
