/**
 * SimpleList.java
 * @version 1.0.0
 * @author Bette Bultena
 */

package evaluator; 

import java.util.*;

/**
 * Class SimpleList is a simple linked list that holds Objects.
 * Presently, adding and removing items can only be done at
 * the front.
 */

public class SimpleList implements SSLInterface {

   private Node head;
   private int size;

//The default constructor is adequate to create the empty list.

   public void addFirst( Object element ) {
      Node temp = new Node( element, head );
      head = temp;
      size++;
   }

   public Object removeFirst() {
      if (size==0) throw new NoSuchElementException("The list is empty");
      Object returnValue = head.getElement();
      head = head.getNext();
      size--;
      return returnValue;
   }

   public Object getFirstValue() {
      if (size==0) throw new NoSuchElementException("The list is empty");
      return head.getElement();
   }

   public int size() {
      return size;
   }

   public String toString() {
	   String s = "The list:\n";
	   for (Node tmp = head; tmp != null; tmp = tmp.getNext()) {
		   s += tmp.getElement() + "\n";
	   }
	   return s;
   }

/**
 * test harness.
 */
 	public static void main( String[] args ) {
		SimpleList s = new SimpleList();
		if (s.size() == 0) {
			System.out.println("size correct when = 0");
		} else {
			System.out.println("error at step 1");
		}
		s.addFirst( new Integer(1) );
		s.addFirst( new Integer(2) );
		System.out.println( (Integer)(s.getFirstValue()) );
		if ( ((Integer)(s.getFirstValue())).intValue() == 2 ) {
			System.out.println("first value is correct");
		} else {
			System.out.println("Error at step 2");
		}
		System.out.println(s.removeFirst() + " was removed");
		if (s.size() == 1) {
			System.out.println("size correct when = 1");
		} else {
			System.out.println("error at step 3");
		}
	}
}