package evaluator; 

import java.util.*;

public class SimpleStack {
	private SimpleList stack;

	public SimpleStack() {
		stack = new SimpleList();
	}

	public void push( Object element ) {
		stack.addFirst( element );
	}

	public Object pop() {
		try {
			return stack.removeFirst();
		} catch (NoSuchElementException e) {
			throw new RuntimeException( "The stack is empty" );
		}
	}

	public Object top() {
		try {
			return stack.getFirstValue();
		} catch (NoSuchElementException e) {
			throw new RuntimeException( "The stack is empty" );
		}
	}

	public boolean isEmpty() {
		return (stack.size() == 0);
	}

	public int size() {
		return stack.size();
	}

	public String toString() {
		return stack.toString();
	}

	public static void main( String[] args ) {
		SimpleStack s = new SimpleStack();
		if (s.isEmpty()) {
			System.out.println("The stack was correctly identified as empty");
		} else {
			System.out.println("The stack was incorrectly identified as non-empty");
		}
		s.push( new Integer(1));
		s.push( new Integer(2));
		s.push( new Integer(3));
		s.push( new Integer(4));
		s.push( new Integer(5) );
		s.push( new Integer(6) );
		System.out.println(s);
		System.out.println("popping the stack:");
		System.out.println(s.pop());
		System.out.println(s.pop());
		//should be looking at 4:
		System.out.println("looking at "+s.top());
		System.out.println(s.pop());
		System.out.println(s.pop());
		System.out.println(s.pop());
		System.out.println(s.pop());
		try {
			System.out.println(s.pop());
			System.out.println("Exception not thrown  BAD");
		} catch (RuntimeException e) {
			System.out.println(e+", GOOD");
		}
	}



}

